Object.defineProperty(exports, "__esModule", { value: true });
var Last = /** @class */ (function () {
    function Last() {
    }
    /**
     * Returns the last element of the sequence or the last element matching `predicate` if present, otherwise throws
     * an error.
     *
     * @param {(value: T) => boolean} predicate
     * @returns {T}
     */
    Last.prototype.last = function (predicate) {
        if (predicate != null) {
            return this.filter(predicate).last();
        }
        if (!this.iterator.hasNext()) {
            throw new Error("No such element");
        }
        var item;
        while (this.iterator.hasNext()) {
            item = this.iterator.next();
        }
        return item;
    };
    return Last;
}());
exports.Last = Last;
//# sourceMappingURL=last.js.map