Object.defineProperty(exports, "__esModule", { value: true });
var MaxBy = /** @class */ (function () {
    function MaxBy() {
    }
    /**
     * Returns the maximum element by comparing the results of the given `selector` function
     * for each element of the sequence or `null` if the sequence is empty.
     *
     * @param {(value: T) => R} selector
     * @returns {T}
     */
    MaxBy.prototype.maxBy = function (selector) {
        var max = null;
        var maxSelected = null;
        while (this.iterator.hasNext()) {
            var item = this.iterator.next();
            var value = selector(item);
            if (maxSelected == null || value > maxSelected) {
                maxSelected = value;
                max = item;
            }
        }
        return max;
    };
    return MaxBy;
}());
exports.MaxBy = MaxBy;
//# sourceMappingURL=maxBy.js.map