Object.defineProperty(exports, "__esModule", { value: true });
var MinBy = /** @class */ (function () {
    function MinBy() {
    }
    /**
     * Returns the minimum element by comparing the results of the given `selector` function
     * for each element of the sequence or `null` if the sequence is empty.
     *
     * @param {(value: T) => R} selector
     * @returns {T}
     */
    MinBy.prototype.minBy = function (selector) {
        var min = null;
        var minSelected = null;
        while (this.iterator.hasNext()) {
            var item = this.iterator.next();
            var value = selector(item);
            if (minSelected == null || value < minSelected) {
                minSelected = value;
                min = item;
            }
        }
        return min;
    };
    return MinBy;
}());
exports.MinBy = MinBy;
//# sourceMappingURL=minBy.js.map