Object.defineProperty(exports, "__esModule", { value: true });
var Sequence_1 = require("./Sequence");
var SequenceIterator_1 = require("./SequenceIterator");
var AppendIterator = /** @class */ (function () {
    function AppendIterator(first, second) {
        this.first = first;
        this.second = second;
    }
    AppendIterator.prototype.hasNext = function () {
        return this.first.hasNext() || this.second.hasNext();
    };
    AppendIterator.prototype.next = function () {
        return this.first.hasNext()
            ? this.first.next()
            : this.second.next();
    };
    return AppendIterator;
}());
var Plus = /** @class */ (function () {
    function Plus() {
    }
    Plus.prototype.plus = function (data) {
        if (Sequence_1.isSequence(data)) {
            return Sequence_1.createSequence(new AppendIterator(this.iterator, data.iterator));
        }
        else if (data instanceof Array) {
            return Sequence_1.createSequence(new AppendIterator(this.iterator, new SequenceIterator_1.IterableIterator(data)));
        }
        else {
            return Sequence_1.createSequence(new AppendIterator(this.iterator, new SequenceIterator_1.IterableIterator([data])));
        }
    };
    return Plus;
}());
exports.Plus = Plus;
//# sourceMappingURL=plus.js.map