Object.defineProperty(exports, "__esModule", { value: true });
var Sequence_1 = require("./Sequence");
var IndexIterator = /** @class */ (function () {
    function IndexIterator(iterator) {
        this.iterator = iterator;
        this.index = -1;
    }
    IndexIterator.prototype.hasNext = function () {
        return this.iterator.hasNext();
    };
    IndexIterator.prototype.next = function () {
        var value = this.iterator.next();
        this.index++;
        return { index: this.index, value: value };
    };
    return IndexIterator;
}());
var WithIndex = /** @class */ (function () {
    function WithIndex() {
    }
    /**
     * Returns a new sequence consisting of indexed values for all original elements.
     *
     * @returns {Sequence<IndexedValue<T>>}
     */
    WithIndex.prototype.withIndex = function () {
        return Sequence_1.createSequence(new IndexIterator(this.iterator));
    };
    return WithIndex;
}());
exports.WithIndex = WithIndex;
//# sourceMappingURL=withIndex.js.map